--- app_voicemail.c.orig	2005-07-06 23:16:38.000000000 +0200
+++ app_voicemail.c	2005-07-06 22:59:07.000000000 +0200
@@ -338,6 +338,7 @@
 static char adsifdn[4] = "\x00\x00\x00\x0F";
 static char adsisec[4] = "\x9B\xDB\xF7\xAC";
 static int adsiver = 1;
+static int emaildateformat;
 
 STANDARD_LOCAL_USER;
 
@@ -1540,6 +1541,20 @@
 		strftime(date, sizeof(date), "%a, %d %b %Y %H:%M:%S %z", &tm);
 		fprintf(p, "Date: %s\n", date);
 
+		/* Set 12 or 24 hour time format on outgoing voicemail mail */
+		if (emaildateformat) {
+			switch (emaildateformat) {
+			case 12:
+				strftime(date, sizeof(date), "%A, %B %d, %Y at %r", &tm);
+				break;
+			case 24:
+				strftime(date, sizeof(date), "%A, %d %B %Y at %H:%M:%S", &tm);
+				break;
+			}
+		}	else {
+			strftime(date, sizeof(date), "%A, %B %d, %Y at %r", &tm); /* Fall back to 12 hours format if not in config file */
+		}
+
 		if (*fromstring) {
 			struct ast_channel *ast = ast_channel_alloc(0);
 			if (ast) {
@@ -1589,7 +1604,6 @@
 			fprintf(p, "--%s\n", bound);
 		}
 		fprintf(p, "Content-Type: text/plain; charset=%s\nContent-Transfer-Encoding: 8bit\n\n", charset);
-		strftime(date, sizeof(date), "%A, %B %d, %Y at %r", &tm);
 		if (emailbody) {
 			struct ast_channel *ast = ast_channel_alloc(0);
 			if (ast) {
@@ -5300,6 +5314,7 @@
 	char *callbackcxt = NULL;	
 	char *exitcxt = NULL;	
 	char *extpc;
+	char *emaildateformatstr;
 	int x;
 	int tmpadsi[4];
 
@@ -5349,6 +5364,20 @@
 				maxsilence *= 1000;
 		}
 
+		/* Check for 12 or 24 hour date format in voicemail mail */
+		if ((emaildateformatstr = ast_variable_retrieve(cfg, "general", "emaildateformat"))) {
+			emaildateformat = atoi(emaildateformatstr);
+			switch(emaildateformat) {
+			case 12:
+			case 24:
+				emaildateformat = atoi(emaildateformatstr);
+				break;
+			default:
+				ast_log(LOG_WARNING, "Invalid emaildateformat: %d set in config. Falling back to 12 hour format.\n", emaildateformat);
+				emaildateformat = 12; /* Fall back to 12 hours format */
+			}
+		}
+
 		/* External password changing command */
 		if ((extpc = ast_variable_retrieve(cfg, "general", "externpass"))) {
 			strncpy(ext_pass_cmd,extpc,sizeof(ext_pass_cmd) - 1);
